---
title: ConstrainBoolean
slug: Web/API/ConstrainBoolean
tags:
  - API
  - ConstrainBooleanParameters
  - Constraints
  - Dictionary
  - Interface
  - Media
  - Media Capture and Streams API
  - Media Streams API
  - Reference
  - Web
  - WebRTC
---
<div>{{APIRef("Media Capture and Streams")}}</div>

<p>The <strong><code>ConstrainBoolean</code></strong> dictionary is used to specify a constraint for a property whose value is a Boolean value. You can specify an exact value which must be matched, an ideal value that should be matched if at all possible, and a fallback value to attempt to match once all more specific constraints have been applied.</p>

<h2 id="Properties">Properties</h2>

<dl>
 <dt><code>exact</code></dt>
 <dd>A Boolean which indicates a value the property must have.</dd>
 <dt><code>ideal</code></dt>
 <dd>A Boolean value indicating the ideal, but not required, value the property should ideally have. If possible, this value will be used, but the user agent will use the other value if it needs to in order to come up with a workable configuration.</dd>
</dl>

<p>You can also specify the value of the property as <code>true</code> or <code>false</code>, in which case the user agent will use that value if possible once all efforts have been made to match the <code>exact</code> and <code>ideal</code> values for other properties.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Media Capture', '#dom-constrainboolean', 'ConstrainBoolean')}}</td>
   <td>{{Spec2('Media Capture')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<div class="note">
<p>Technically, <code>ConstrainBoolean</code> is actually based on an intermediary dictionary named <code>ConstrainBooleanParameters</code>, which adds <code>exact</code> and <code>ideal</code> to the simple Boolean type. However, for the sake of documentation clarity, the intermediate type (present only because of quirks in {{Glossary("WebIDL")}} syntax) is ignored here.</p>
</div>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.ConstrainBoolean")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Media_Streams_API">Media Capture and Streams API</a></li>
 <li><a href="/en-US/docs/Web/API/Media_Streams_API/Constraints">Capabilities, constraints, and settings</a></li>
 <li>{{domxref("MediaTrackConstraints")}}</li>
 <li>{{domxref("MediaTrackCapabilities")}}</li>
 <li>{{domxref("MediaTrackSupportedConstraints")}}</li>
</ul>
